/*
 * @Copyright 2010, MechSoft 
 * MechSoft, Mechanical and Software Solutions 
 * 
 * Licensed under the Apache License, Version 2.0 (the 
 * "License"); you may not use this file except in compliance 
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.defne.server.servlet;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.defne.owb.PojoServiceExecutor;
import org.defne.service.Message;
import org.defne.utility.log.ILogger;
import org.defne.utility.log.LoggerProvider;

/**
 * Defne JSON servlet.
 * @author gurkanerdogdu
 * @version $Rev$ $Date$
 */
public class DefneSerializeServlet extends HttpServlet
{
    private static final long serialVersionUID = 1L;
    
    private static final ILogger logger = LoggerProvider.getLogProvider(DefneSerializeServlet.class);

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException
    {
        resp.sendError(HttpServletResponse.SC_METHOD_NOT_ALLOWED, "Get is not supported");
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException
    {
        try
        {
            ObjectInputStream ois = new ObjectInputStream(req.getInputStream());
            Message object =  (Message)ois.readObject();
            
            object = PojoServiceExecutor.execute(object);
            ObjectOutputStream oos = new ObjectOutputStream(resp.getOutputStream());
            oos.writeObject(object);
            oos.flush();
            
        }catch(Exception e)
        {
            logger.error(e);
            ObjectOutputStream oos = new ObjectOutputStream(resp.getOutputStream());
            oos.writeObject(e);
            oos.flush();
        }
    }

    
}
